/**
 * @file
 * Popup behaviors.
 */

(function ($) {

  // Function to set the Cookie.
  function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires;
  }

  // Retrieve the cookie which is used to show the popup.
  function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
      var c = ca[i];
      while (c.charAt(0) == ' ') {
        c = c.substring(1);
      }
      if (c.indexOf(name) == 0) {
        return c.substring(name.length, c.length);
      }
    }
    return "";
  }

  /**
   * Disabling popup.
   */
  function popupDisable() {
    // Disables popup only if it is enabled.
    $("#popup-dialog-window").fadeOut("slow");
    $("#popup-dialog-background").fadeOut("slow");
  }

  // Popup markup and displaying it.
  function displayPopup(title, body, top) {
    $('body')
      .append("<div id='popup-dialog-window' style='top: " + top + "px;'><div id='popup-header'><h2 id='popup-dialog-title'>" + title + "</h2><span id='close-dialog'>X</span></div><div id='popup-dialog-content'>" + body + "</div></div><div id='popup-dialog-background'></div>");

    // Closing popup.
    // Click the x event!
    $("#close-dialog").click(function () {
      popupDisable();
    });

    // Click out event!
    $("#popup-dialog-background").click(function () {
      popupDisable();
    });
  }

  // Drupal behaviors for the popup.
  Drupal.behaviors.popup = {
    attach: function (context, settings) {
      var user = getCookie("FirstUser");
      var enabled = settings.enabled;
      var title = settings.title;
      var body = settings.body;
      var delay = settings.delay + "000";
      var top = settings.top;
      if (user == "" && enabled == 1) {
        var showpopup = function () {
          setCookie("FirstUser", 1, 365);
          displayPopup(title, body, top);
        };
        setTimeout(showpopup, delay);
      }
    }
  };
})(jQuery);
